package cn.com.infosec.asn1.x509;

import cn.com.infosec.asn1.ASN1Choice;
import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1TaggedObject;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERTaggedObject;

public class Target extends ASN1Encodable implements ASN1Choice {
   public static final int targetName = 0;
   public static final int targetGroup = 1;
   private GeneralName targName;
   private GeneralName targGroup;

   public static Target getInstance(Object obj) {
      if (obj instanceof Target) {
         return (Target)obj;
      } else if (obj instanceof ASN1TaggedObject) {
         return new Target((ASN1TaggedObject)obj);
      } else {
         throw new IllegalArgumentException("unknown object in factory: " + obj.getClass());
      }
   }

   private Target(ASN1TaggedObject tagObj) {
      int var2;
      if ((var2 = tagObj.getTagNo()) != 0) {
         if (var2 != 1) {
            throw new IllegalArgumentException("unknown tag: " + tagObj.getTagNo());
         }

         this.targGroup = GeneralName.getInstance(tagObj, true);
      } else {
         this.targName = GeneralName.getInstance(tagObj, true);
      }

   }

   public Target(int type, GeneralName name) {
      Target var10000 = this;
      DERTaggedObject var3;
      var3 = new DERTaggedObject.<init>(type, name);
      var10000.<init>(var3);
   }

   public GeneralName getTargetGroup() {
      return this.targGroup;
   }

   public GeneralName getTargetName() {
      return this.targName;
   }

   public DERObject toASN1Object() {
      GeneralName var1;
      if ((var1 = this.targName) != null) {
         return new DERTaggedObject(true, 0, var1);
      } else {
         GeneralName var2 = this.targGroup;
         return new DERTaggedObject(true, 1, var2);
      }
   }
}
